Only in jsch-0.1.44: build
Only in jsch-0.1.44: .classpath
Only in jsch-0.1.44/dist/lib: jsch-20110221.jar
Only in jsch-0.1.44/dist/lib: jsch-20110302.jar
Only in jsch-0.1.44/examples: AES.class
Only in jsch-0.1.44/examples: AES$MyUserInfo.class
Only in jsch-0.1.44/examples: ChangePassphrase.class
Only in jsch-0.1.44/examples: Compression.class
Only in jsch-0.1.44/examples: Compression$MyUserInfo.class
Only in jsch-0.1.44/examples: Daemon.class
Only in jsch-0.1.44/examples: Daemon$MyUserInfo.class
Only in jsch-0.1.44/examples: Daemon$Parrot.class
Only in jsch-0.1.44/examples: Exec.class
Only in jsch-0.1.44/examples: Exec$MyUserInfo.class
Only in jsch-0.1.44/examples: KeyGen.class
Only in jsch-0.1.44/examples: KnownHosts.class
Only in jsch-0.1.44/examples: KnownHosts$MyUserInfo.class
Only in jsch-0.1.44/examples: Logger.class
Only in jsch-0.1.44/examples: Logger$MyLogger.class
Only in jsch-0.1.44/examples: Logger$MyUserInfo.class
Only in jsch-0.1.44/examples: PortForwardingL.class
Only in jsch-0.1.44/examples: PortForwardingL$MyUserInfo.class
Only in jsch-0.1.44/examples: PortForwardingR.class
Only in jsch-0.1.44/examples: PortForwardingR$MyUserInfo.class
Only in jsch-0.1.44/examples: ScpFrom.class
Only in jsch-0.1.44/examples: ScpFrom$MyUserInfo.class
Only in jsch-0.1.44/examples: ScpTo.class
diff -urw jsch-0.1.44-clean//examples/ScpTo.java jsch-0.1.44/examples/ScpTo.java
--- jsch-0.1.44-clean//examples/ScpTo.java	2010-02-05 11:30:35.000000000 +0900
+++ jsch-0.1.44/examples/ScpTo.java	2011-03-08 14:04:26.555426001 +0900
@@ -3,15 +3,24 @@
 import java.awt.*;
 import javax.swing.*;
 import java.io.*;
+import java.security.Provider;
+import java.security.Security;
 
 public class ScpTo{
-  public static void main(String[] arg){
+	
+	private static final String PRIVATE_KEY = "/home/watcharin/.ssh/id_rsa";
+	
+	private static final String MESSAGE = "Text sent by scp\n";
+	
+	private static final int PORT = 8000;
+	
+  public static void main(String[] arg) throws JSchException {
     if(arg.length!=2){
       System.err.println("usage: java ScpTo file1 user@remotehost:file2");
       System.exit(-1);
     }      
 
-    FileInputStream fis=null;
+//    FileInputStream fis=null;
     try{
 
       String lfile=arg[0];
@@ -21,7 +30,9 @@
       String rfile=arg[1].substring(arg[1].indexOf(':')+1);
 
       JSch jsch=new JSch();
-      Session session=jsch.getSession(user, host, 22);
+			jsch.addIdentity(PRIVATE_KEY);
+
+			Session session = jsch.getSession(user, host, PORT);
 
       // username and password will be given via UserInfo interface.
       UserInfo ui=new MyUserInfo();
@@ -45,46 +56,59 @@
 	System.exit(0);
       }
 
-      File _lfile = new File(lfile);
+			// File _lfile = new File(lfile);
 
       if(ptimestamp){
-        command="T "+(_lfile.lastModified()/1000)+" 0";
+				long lastMod = 1276004506000L;
+
+				command = "T " + (lastMod / 1000) + " 0";
         // The access time should be sent here,
         // but it is not accessible with JavaAPI ;-<
-        command+=(" "+(_lfile.lastModified()/1000)+" 0\n"); 
-        out.write(command.getBytes()); out.flush();
+				command += (" " + (lastMod / 1000) + " 0\n");
+				System.out.printf("[MAIN] Write command\n");
+				out.write(command.getBytes());
+				out.flush();
         if(checkAck(in)!=0){
   	  System.exit(0);
         }
       }
 
-      // send "C0644 filesize filename", where filename should not include '/'
-      long filesize=_lfile.length();
+			// send "C0644 filesize filename", where filename should not include
+			// '/'
+			// long filesize=_lfile.length();
+			long filesize = MESSAGE.length();
       command="C0644 "+filesize+" ";
       if(lfile.lastIndexOf('/')>0){
         command+=lfile.substring(lfile.lastIndexOf('/')+1);
-      }
-      else{
+			} else {
         command+=lfile;
       }
       command+="\n";
-      out.write(command.getBytes()); out.flush();
+			out.write(command.getBytes());
+			out.flush();
       if(checkAck(in)!=0){
 	System.exit(0);
       }
 
       // send a content of lfile
-      fis=new FileInputStream(lfile);
-      byte[] buf=new byte[1024];
-      while(true){
-        int len=fis.read(buf, 0, buf.length);
-	if(len<=0) break;
-        out.write(buf, 0, len); //out.flush();
-      }
-      fis.close();
-      fis=null;
+			// fis=new FileInputStream(lfile);
+			// byte[] buf=new byte[1024];
+			byte[] buf = MESSAGE.getBytes();
+			// while(true){
+			// int len=fis.read(buf, 0, buf.length);
+			// if(len<=0) break;
+			// out.write(buf, 0, len); //out.flush();
+			// }
+			System.out.printf("[MAIN] send a content of lfile\n");
+			out.write(buf, 0, buf.length);
+			out.flush();
+
+			// fis.close();
+			// fis=null;
       // send '\0'
-      buf[0]=0; out.write(buf, 0, 1); out.flush();
+			buf[0] = 0;
+			out.write(buf, 0, 1);
+			out.flush();
       if(checkAck(in)!=0){
 	System.exit(0);
       }
@@ -94,10 +118,9 @@
       session.disconnect();
 
       System.exit(0);
-    }
-    catch(Exception e){
-      System.out.println(e);
-      try{if(fis!=null)fis.close();}catch(Exception ee){}
+		} catch (IOException e) {
+			e.printStackTrace();
+			// try{if(fis!=null)fis.close();}catch(Exception ee){}
     }
   }
 
@@ -142,80 +165,82 @@
     }
   
     String passwd;
-    JTextField passwordField=(JTextField)new JPasswordField(20);
+//    JTextField passwordField=(JTextField)new JPasswordField(20);
 
     public String getPassphrase(){ return null; }
     public boolean promptPassphrase(String message){ return true; }
     public boolean promptPassword(String message){
-      Object[] ob={passwordField}; 
-      int result=
-	  JOptionPane.showConfirmDialog(null, ob, message,
-					JOptionPane.OK_CANCEL_OPTION);
-      if(result==JOptionPane.OK_OPTION){
-	passwd=passwordField.getText();
-	return true;
-      }
-      else{ return false; }
+//      Object[] ob={passwordField}; 
+//      int result=
+//	  JOptionPane.showConfirmDialog(null, ob, message,
+//					JOptionPane.OK_CANCEL_OPTION);
+//      if(result==JOptionPane.OK_OPTION){
+//	passwd=passwordField.getText();
+//	return true;
+//      }
+//      else{ return false; }
+    	return false;
     }
     public void showMessage(String message){
       JOptionPane.showMessageDialog(null, message);
     }
-    final GridBagConstraints gbc = 
-      new GridBagConstraints(0,0,1,1,1,1,
-                             GridBagConstraints.NORTHWEST,
-                             GridBagConstraints.NONE,
-                             new Insets(0,0,0,0),0,0);
+//    final GridBagConstraints gbc = 
+//      new GridBagConstraints(0,0,1,1,1,1,
+//                             GridBagConstraints.NORTHWEST,
+//                             GridBagConstraints.NONE,
+//                             new Insets(0,0,0,0),0,0);
     private Container panel;
     public String[] promptKeyboardInteractive(String destination,
                                               String name,
                                               String instruction,
                                               String[] prompt,
                                               boolean[] echo){
-      panel = new JPanel();
-      panel.setLayout(new GridBagLayout());
-
-      gbc.weightx = 1.0;
-      gbc.gridwidth = GridBagConstraints.REMAINDER;
-      gbc.gridx = 0;
-      panel.add(new JLabel(instruction), gbc);
-      gbc.gridy++;
-
-      gbc.gridwidth = GridBagConstraints.RELATIVE;
-
-      JTextField[] texts=new JTextField[prompt.length];
-      for(int i=0; i<prompt.length; i++){
-        gbc.fill = GridBagConstraints.NONE;
-        gbc.gridx = 0;
-        gbc.weightx = 1;
-        panel.add(new JLabel(prompt[i]),gbc);
-
-        gbc.gridx = 1;
-        gbc.fill = GridBagConstraints.HORIZONTAL;
-        gbc.weighty = 1;
-        if(echo[i]){
-          texts[i]=new JTextField(20);
-        }
-        else{
-          texts[i]=new JPasswordField(20);
-        }
-        panel.add(texts[i], gbc);
-        gbc.gridy++;
-      }
-
-      if(JOptionPane.showConfirmDialog(null, panel, 
-                                       destination+": "+name,
-                                       JOptionPane.OK_CANCEL_OPTION,
-                                       JOptionPane.QUESTION_MESSAGE)
-         ==JOptionPane.OK_OPTION){
-        String[] response=new String[prompt.length];
-        for(int i=0; i<prompt.length; i++){
-          response[i]=texts[i].getText();
-        }
-	return response;
-      }
-      else{
-        return null;  // cancel
-      }
+//      panel = new JPanel();
+//      panel.setLayout(new GridBagLayout());
+//
+//      gbc.weightx = 1.0;
+//      gbc.gridwidth = GridBagConstraints.REMAINDER;
+//      gbc.gridx = 0;
+//      panel.add(new JLabel(instruction), gbc);
+//      gbc.gridy++;
+//
+//      gbc.gridwidth = GridBagConstraints.RELATIVE;
+//
+//      JTextField[] texts=new JTextField[prompt.length];
+//      for(int i=0; i<prompt.length; i++){
+//        gbc.fill = GridBagConstraints.NONE;
+//        gbc.gridx = 0;
+//        gbc.weightx = 1;
+//        panel.add(new JLabel(prompt[i]),gbc);
+//
+//        gbc.gridx = 1;
+//        gbc.fill = GridBagConstraints.HORIZONTAL;
+//        gbc.weighty = 1;
+//        if(echo[i]){
+//          texts[i]=new JTextField(20);
+//        }
+//        else{
+//          texts[i]=new JPasswordField(20);
+//        }
+//        panel.add(texts[i], gbc);
+//        gbc.gridy++;
+//      }
+//
+//      if(JOptionPane.showConfirmDialog(null, panel, 
+//                                       destination+": "+name,
+//                                       JOptionPane.OK_CANCEL_OPTION,
+//                                       JOptionPane.QUESTION_MESSAGE)
+//         ==JOptionPane.OK_OPTION){
+//        String[] response=new String[prompt.length];
+//        for(int i=0; i<prompt.length; i++){
+//          response[i]=texts[i].getText();
+//        }
+//	return response;
+//      }
+//      else{
+//        return null;  // cancel
+//      }
+    	return null;
     }
   }
 }
Only in jsch-0.1.44/examples: ScpTo$MyUserInfo.class
Only in jsch-0.1.44/examples: ScpToNoneCipher.class
Only in jsch-0.1.44/examples: ScpToNoneCipher$MyUserInfo.class
Only in jsch-0.1.44/examples: Sftp.class
Only in jsch-0.1.44/examples: Sftp$MyProgressMonitor.class
Only in jsch-0.1.44/examples: Sftp$MyUserInfo.class
Only in jsch-0.1.44/examples: Shell.class
Only in jsch-0.1.44/examples: Shell$MyUserInfo.class
Only in jsch-0.1.44/examples: StreamForwarding.class
Only in jsch-0.1.44/examples: StreamForwarding$MyUserInfo.class
Only in jsch-0.1.44/examples: Subsystem.class
Only in jsch-0.1.44/examples: Subsystem$MyUserInfo.class
Only in jsch-0.1.44/examples: UserAuthKI.class
Only in jsch-0.1.44/examples: UserAuthKI$MyUserInfo.class
Only in jsch-0.1.44/examples: UserAuthPubKey.class
Only in jsch-0.1.44/examples: UserAuthPubKey$MyUserInfo.class
Only in jsch-0.1.44/examples: ViaHTTP.class
Only in jsch-0.1.44/examples: ViaHTTP$MyUserInfo.class
Only in jsch-0.1.44/examples: ViaSOCKS5.class
Only in jsch-0.1.44/examples: ViaSOCKS5$MyUserInfo.class
Only in jsch-0.1.44/examples: X11Forwarding.class
Only in jsch-0.1.44/examples: X11Forwarding$MyUserInfo.class
Only in jsch-0.1.44: .project
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/Session.java jsch-0.1.44/src/com/jcraft/jsch/Session.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/Session.java	2010-10-26 17:09:12.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/Session.java	2011-03-08 15:15:55.375426001 +0900
@@ -164,8 +164,7 @@
       try{
 	Class c=Class.forName(getConfig("random"));
         random=(Random)(c.newInstance());
-      }
-      catch(Exception e){ 
+			} catch (Exception e) {
         throw new JSchException(e.toString(), e);
       }
     }
@@ -186,8 +185,7 @@
           socket=Util.createSocket(host, port, connectTimeout);
 	  in=socket.getInputStream();
 	  out=socket.getOutputStream();
-	}
-	else{
+				} else {
           socket=socket_factory.createSocket(host, port);
 	  in=socket_factory.getInputStream(socket);
 	  out=socket_factory.getOutputStream(socket);
@@ -196,8 +194,7 @@
         socket.setTcpNoDelay(true);
         io.setInputStream(in);
         io.setOutputStream(out);
-      }
-      else{
+			} else {
 	synchronized(proxy){
           proxy.connect(socket_factory, host, port, connectTimeout);
 	  io.setInputStream(proxy.getInputStream());
@@ -212,15 +209,15 @@
 
       isConnected=true;
 
-      if(JSch.getLogger().isEnabled(Logger.INFO)){
-        JSch.getLogger().log(Logger.INFO, 
-                             "Connection established");
-      }
+			// if (JSch.getLogger().isEnabled(Logger.INFO)) {
+			// JSch.getLogger().log(Logger.INFO, "Connection established");
+			// }
 
       jsch.addSession(this);
 
       {
-	// Some Cisco devices will miss to read '\n' if it is sent separately.
+				// Some Cisco devices will miss to read '\n' if it is sent
+				// separately.
 	byte[] foo=new byte[V_C.length+1];
 	System.arraycopy(V_C, 0, foo, 0, V_C.length);
 	foo[foo.length-1]=(byte)'\n';
@@ -232,12 +229,16 @@
         j=0;
         while(i<buf.buffer.length){
           j=io.getByte();
-          if(j<0)break;
-          buf.buffer[i]=(byte)j; i++; 
-          if(j==10)break;
+					if (j < 0)
+						break;
+					buf.buffer[i] = (byte) j;
+					i++;
+					if (j == 10)
+						break;
         }
         if(j<0){
-          throw new JSchException("connection is closed by foreign host");
+					throw new JSchException(
+							"connection is closed by foreign host");
         }
 
         if(buf.buffer[i-1]==10){    // 0x0a
@@ -247,17 +248,15 @@
           }
         }
 
-        if(i<=3 || 
-           ((i!=buf.buffer.length) &&
-            (buf.buffer[0]!='S'||buf.buffer[1]!='S'||
-             buf.buffer[2]!='H'||buf.buffer[3]!='-'))){
+				if (i <= 3
+						|| ((i != buf.buffer.length) && (buf.buffer[0] != 'S'
+								|| buf.buffer[1] != 'S' || buf.buffer[2] != 'H' || buf.buffer[3] != '-'))) {
           // It must not start with 'SSH-'
           //System.err.println(new String(buf.buffer, 0, i);
           continue;
         }
 
-        if(i==buf.buffer.length ||
-           i<7 ||                                      // SSH-1.99 or SSH-2.0
+				if (i == buf.buffer.length || i < 7 || // SSH-1.99 or SSH-2.0
            (buf.buffer[4]=='1' && buf.buffer[6]!='9')  // SSH-1.5
            ){
           throw new JSchException("invalid server's version string");
@@ -265,7 +264,8 @@
         break;
       }
 
-      V_S=new byte[i]; System.arraycopy(buf.buffer, 0, V_S, 0, i);
+			V_S = new byte[i];
+			System.arraycopy(buf.buffer, 0, V_S, 0, i);
       //System.err.println("V_S: ("+i+") ["+new String(V_S)+"]");
 
       if(JSch.getLogger().isEnabled(Logger.INFO)){
@@ -283,10 +283,9 @@
 	throw new JSchException("invalid protocol: "+buf.getCommand());
       }
 
-      if(JSch.getLogger().isEnabled(Logger.INFO)){
-        JSch.getLogger().log(Logger.INFO, 
-                             "SSH_MSG_KEXINIT received");
-      }
+			// if (JSch.getLogger().isEnabled(Logger.INFO)) {
+			// JSch.getLogger().log(Logger.INFO, "SSH_MSG_KEXINIT received");
+			// }
 
       KeyExchange kex=receive_kexinit(buf);
 
@@ -300,18 +299,19 @@
             in_kex=false;
 	    throw new JSchException("verify: "+result);
 	  }
-	}
-	else{
+				} else {
           in_kex=false;
-	  throw new JSchException("invalid protocol(kex): "+buf.getCommand());
+					throw new JSchException("invalid protocol(kex): "
+							+ buf.getCommand());
 	}
 	if(kex.getState()==KeyExchange.STATE_END){
 	  break;
 	}
       }
 
-      try{ checkHost(host, port, kex); }
-      catch(JSchException ee){
+			try {
+				checkHost(host, port, kex);
+			} catch (JSchException ee) {
         in_kex=false;
         throw ee;
       }
@@ -329,10 +329,10 @@
         }
 
 	receive_newkeys(buf, kex);
-      }
-      else{
+			} else {
         in_kex=false;
-	throw new JSchException("invalid protocol(newkyes): "+buf.getCommand());
+				throw new JSchException("invalid protocol(newkyes): "
+						+ buf.getCommand());
       }
 
       boolean auth=false;
@@ -342,8 +342,7 @@
       try{
 	Class c=Class.forName(getConfig("userauth.none"));
         ua=(UserAuth)(c.newInstance());
-      }
-      catch(Exception e){ 
+			} catch (Exception e) {
         throw new JSchException(e.toString(), e);
       }
 
@@ -357,8 +356,7 @@
         smethods=((UserAuthNone)ua).getMethods();
         if(smethods!=null){
           smethods=smethods.toLowerCase();
-        }
-        else{
+				} else {
           // methods: publickey,password,keyboard-interactive
           //smethods="publickey,password,keyboard-interactive";
           smethods=cmethods;
@@ -369,13 +367,11 @@
 
       int methodi=0;
 
-      loop:
-      while(true){
+			loop: while (true) {
 
 //System.err.println("methods: "+methods);
 
-	while(!auth && 
-	      cmethoda!=null && methodi<cmethoda.length){
+				while (!auth && cmethoda != null && methodi < cmethoda.length) {
 
           String method=cmethoda[methodi++];
           boolean acceptable=false;
@@ -398,8 +394,7 @@
               if(k+1<cmethoda.length)
                 str+=",";
             }
-            JSch.getLogger().log(Logger.INFO, 
-                                 str);
+						JSch.getLogger().log(Logger.INFO, str);
             JSch.getLogger().log(Logger.INFO, 
                                  "Next authentication method: "+method);
           }
@@ -411,8 +406,7 @@
               c=Class.forName(getConfig("userauth."+method));
               ua=(UserAuth)(c.newInstance());
             }
-          }
-          catch(Exception e){
+					} catch (Exception e) {
             if(JSch.getLogger().isEnabled(Logger.WARN)){
               JSch.getLogger().log(Logger.WARN, 
                                    "failed to load "+method+" method");
@@ -423,16 +417,15 @@
             auth_cancel=false;
 	    try{ 
 	      auth=ua.start(this); 
-              if(auth && 
-                 JSch.getLogger().isEnabled(Logger.INFO)){
-                JSch.getLogger().log(Logger.INFO, 
-                                     "Authentication succeeded ("+method+").");
+							if (auth && JSch.getLogger().isEnabled(Logger.INFO)) {
+								JSch.getLogger().log(
+										Logger.INFO,
+										"Authentication succeeded (" + method
+												+ ").");
               }
-	    }
-	    catch(JSchAuthCancelException ee){
+						} catch (JSchAuthCancelException ee) {
 	      auth_cancel=true;
-	    }
-	    catch(JSchPartialAuthException ee){
+						} catch (JSchPartialAuthException ee) {
               String tmp = smethods;
               smethods=ee.getMethods();
               smethoda=Util.split(smethods, ",");
@@ -442,12 +435,12 @@
 	      //System.err.println("PartialAuth: "+methods);
 	      auth_cancel=false;
 	      continue loop;
-	    }
-	    catch(RuntimeException ee){
+						} catch (RuntimeException ee) {
 	      throw ee;
-	    }
-	    catch(Exception ee){
-	      //System.err.println("ee: "+ee); // SSH_MSG_DISCONNECT: 2 Too many authentication failures
+						} catch (Exception ee) {
+							// System.err.println("ee: "+ee); //
+							// SSH_MSG_DISCONNECT: 2 Too many authentication
+							// failures
               break loop;
 	    }
 	  }
@@ -470,19 +463,18 @@
       synchronized(lock){
         if(isConnected){
           connectThread=new Thread(this);
-          connectThread.setName("Connect thread "+host+" session");
+					connectThread
+							.setName("Connect thread " + host + " session");
           if(daemon_thread){
             connectThread.setDaemon(daemon_thread);
           }
           connectThread.start();
-        }
-        else{
+				} else {
           // The session has been already down and
           // we don't have to start new thread.
         }
       }
-    }
-    catch(Exception e) {
+		} catch (Exception e) {
       in_kex=false;
       if(isConnected){
 	try{
@@ -493,17 +485,17 @@
 	  buf.putString(Util.str2byte("en"));
 	  write(packet);
 	  disconnect();
-	}
-	catch(Exception ee){
+				} catch (Exception ee) {
 	}
       }
       isConnected=false;
-      //e.printStackTrace();
-      if(e instanceof RuntimeException) throw (RuntimeException)e;
-      if(e instanceof JSchException) throw (JSchException)e;
+			e.printStackTrace();
+			if (e instanceof RuntimeException)
+				throw (RuntimeException) e;
+			if (e instanceof JSchException)
+				throw (JSchException) e;
       throw new JSchException("Session.connect: "+e);
-    }
-    finally{
+		} finally {
       Util.bzero(this.password);
       this.password=null;
     }
@@ -514,8 +506,7 @@
     if(j!=buf.getLength()){    // packet was compressed and
       buf.getByte();           // j is the size of deflated packet.
       I_S=new byte[buf.index-5];
-    }
-    else{
+		} else {
       I_S=new byte[j-1-buf.getByte()];
     }
    System.arraycopy(buf.buffer, buf.s, I_S, 0, I_S.length);
@@ -529,29 +520,33 @@
       throw new JSchException("Algorithm negotiation fail");
     }
 
-    if(!isAuthed &&
-       (guess[KeyExchange.PROPOSAL_ENC_ALGS_CTOS].equals("none") ||
-        (guess[KeyExchange.PROPOSAL_ENC_ALGS_STOC].equals("none")))){
-      throw new JSchException("NONE Cipher should not be chosen before authentification is successed.");
+		if (!isAuthed
+				&& (guess[KeyExchange.PROPOSAL_ENC_ALGS_CTOS].equals("none") || (guess[KeyExchange.PROPOSAL_ENC_ALGS_STOC]
+						.equals("none")))) {
+			throw new JSchException(
+					"NONE Cipher should not be chosen before authentification is successed.");
     }
 
     KeyExchange kex=null;
     try{
-      Class c=Class.forName(getConfig(guess[KeyExchange.PROPOSAL_KEX_ALGS]));
+			Class c = Class
+					.forName(getConfig(guess[KeyExchange.PROPOSAL_KEX_ALGS]));
       kex=(KeyExchange)(c.newInstance());
-    }
-    catch(Exception e){ 
+		} catch (Exception e) {
       throw new JSchException(e.toString(), e);
     }
 
     kex.init(this, V_S, V_C, I_S, I_C);
+
     return kex;
   }
 
   private boolean in_kex=false;
+
   public void rekey() throws Exception {
     send_kexinit();
   }
+
   private void send_kexinit() throws Exception {
     if(in_kex)
       return;
@@ -559,7 +554,8 @@
     String cipherc2s=getConfig("cipher.c2s");
     String ciphers2c=getConfig("cipher.s2c");
 
-    String[] not_available=checkCiphers(getConfig("CheckCiphers"));
+		// String[] not_available=checkCiphers(getConfig("CheckCiphers"));
+		String[] not_available = new String[0];
     if(not_available!=null && not_available.length>0){
       cipherc2s=Util.diffString(cipherc2s, not_available);
       ciphers2c=Util.diffString(ciphers2c, not_available);
@@ -588,7 +584,8 @@
     packet.reset();
     buf.putByte((byte) SSH_MSG_KEXINIT);
     synchronized(random){
-      random.fill(buf.buffer, buf.index, 16); buf.skip(16);
+			random.fill(buf.buffer, buf.index, 16);
+			buf.skip(16);
     }
     buf.putString(Util.str2byte(getConfig("kex")));
     buf.putString(Util.str2byte(getConfig("server_host_key")));
@@ -610,8 +607,7 @@
     write(packet);
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "SSH_MSG_KEXINIT sent");
+			JSch.getLogger().log(Logger.INFO, "SSH_MSG_KEXINIT sent");
     }
   }
 
@@ -622,12 +618,12 @@
     write(packet);
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "SSH_MSG_NEWKEYS sent");
+			JSch.getLogger().log(Logger.INFO, "SSH_MSG_NEWKEYS sent");
     }
   }
 
-  private void checkHost(String chost, int port, KeyExchange kex) throws JSchException {
+	private void checkHost(String chost, int port, KeyExchange kex)
+			throws JSchException {
     String shkc=getConfig("StrictHostKeyChecking");
 
     if(hostKeyAlias!=null){
@@ -654,32 +650,40 @@
 
     boolean insert=false;
 
-    if((shkc.equals("ask") || shkc.equals("yes")) &&
-       i==HostKeyRepository.CHANGED){
+		if ((shkc.equals("ask") || shkc.equals("yes"))
+				&& i == HostKeyRepository.CHANGED) {
       String file=null;
       synchronized(hkr){
 	file=hkr.getKnownHostsRepositoryID();
       }
-      if(file==null){file="known_hosts";}
+			if (file == null) {
+				file = "known_hosts";
+			}
 
       boolean b=false;
 
       if(userinfo!=null){
-        String message=
-"WARNING: REMOTE HOST IDENTIFICATION HAS CHANGED!\n"+
-"IT IS POSSIBLE THAT SOMEONE IS DOING SOMETHING NASTY!\n"+
-"Someone could be eavesdropping on you right now (man-in-the-middle attack)!\n"+
-"It is also possible that the "+key_type+" host key has just been changed.\n"+
-"The fingerprint for the "+key_type+" key sent by the remote host is\n"+
-key_fprint+".\n"+
-"Please contact your system administrator.\n"+
-"Add correct host key in "+file+" to get rid of this message.";
+				String message = "WARNING: REMOTE HOST IDENTIFICATION HAS CHANGED!\n"
+						+ "IT IS POSSIBLE THAT SOMEONE IS DOING SOMETHING NASTY!\n"
+						+ "Someone could be eavesdropping on you right now (man-in-the-middle attack)!\n"
+						+ "It is also possible that the "
+						+ key_type
+						+ " host key has just been changed.\n"
+						+ "The fingerprint for the "
+						+ key_type
+						+ " key sent by the remote host is\n"
+						+ key_fprint
+						+ ".\n"
+						+ "Please contact your system administrator.\n"
+						+ "Add correct host key in "
+						+ file
+						+ " to get rid of this message.";
 
         if(shkc.equals("ask")){
-          b=userinfo.promptYesNo(message+
-                                 "\nDo you want to delete the old key and insert the new key?");
-        }
-        else{  // shkc.equals("yes")
+					b = userinfo
+							.promptYesNo(message
+									+ "\nDo you want to delete the old key and insert the new key?");
+				} else { // shkc.equals("yes")
           userinfo.showMessage(message);
         }
       }
@@ -689,60 +693,56 @@
       }
 
       synchronized(hkr){
-        hkr.remove(chost, 
-                   (key_type.equals("DSA") ? "ssh-dss" : "ssh-rsa"), 
-                   null);
+				hkr.remove(chost, (key_type.equals("DSA") ? "ssh-dss"
+						: "ssh-rsa"), null);
         insert=true;
       }
     }
 
-    if((shkc.equals("ask") || shkc.equals("yes")) &&
-       (i!=HostKeyRepository.OK) && !insert){
+		if ((shkc.equals("ask") || shkc.equals("yes"))
+				&& (i != HostKeyRepository.OK) && !insert) {
       if(shkc.equals("yes")){
 	throw new JSchException("reject HostKey: "+host);
       }
       //System.err.println("finger-print: "+key_fprint);
       if(userinfo!=null){
-	boolean foo=userinfo.promptYesNo(
-"The authenticity of host '"+host+"' can't be established.\n"+
-key_type+" key fingerprint is "+key_fprint+".\n"+
-"Are you sure you want to continue connecting?"
-					 );
+				boolean foo = true;
 	if(!foo){
 	  throw new JSchException("reject HostKey: "+host);
 	}
 	insert=true;
-      }
-      else{
+			} else {
 	if(i==HostKeyRepository.NOT_INCLUDED) 
-	  throw new JSchException("UnknownHostKey: "+host+". "+key_type+" key fingerprint is "+key_fprint);
+					throw new JSchException("UnknownHostKey: " + host + ". "
+							+ key_type + " key fingerprint is " + key_fprint);
 	else 
           throw new JSchException("HostKey has been changed: "+host);
       }
     }
 
-    if(shkc.equals("no") && 
-       HostKeyRepository.NOT_INCLUDED==i){
+		if (shkc.equals("no") && HostKeyRepository.NOT_INCLUDED == i) {
       insert=true;
     }
 
-    if(i==HostKeyRepository.OK &&
-       JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "Host '"+host+"' is known and mathces the "+key_type+" host key");
+		if (i == HostKeyRepository.OK
+				&& JSch.getLogger().isEnabled(Logger.INFO)) {
+			JSch.getLogger().log(
+					Logger.INFO,
+					"Host '" + host + "' is known and mathces the " + key_type
+							+ " host key");
     }
 
-    if(insert &&
-       JSch.getLogger().isEnabled(Logger.WARN)){
-      JSch.getLogger().log(Logger.WARN, 
-                           "Permanently added '"+host+"' ("+key_type+") to the list of known hosts.");
+		if (insert && JSch.getLogger().isEnabled(Logger.WARN)) {
+			JSch.getLogger().log(
+					Logger.WARN,
+					"Permanently added '" + host + "' (" + key_type
+							+ ") to the list of known hosts.");
     }
 
     String hkh=getConfig("HashKnownHosts");
     if(hkh.equals("yes") && (hkr instanceof KnownHosts)){
       hostkey=((KnownHosts)hkr).createHashedHostKey(chost, K_S);
-    }
-    else{
+		} else {
       hostkey=new HostKey(chost, K_S);
     }
 
@@ -766,8 +766,7 @@
       addChannel(channel);
       channel.init();
       return channel;
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //e.printStackTrace();
     }
     return null;
@@ -781,18 +780,18 @@
 //Thread.dumpStack();
 //}
     if(deflater!=null){
-      packet.buffer.index=deflater.compress(packet.buffer.buffer, 
-					    5, packet.buffer.index);
+			packet.buffer.index = deflater.compress(packet.buffer.buffer, 5,
+					packet.buffer.index);
     }
     if(c2scipher!=null){
       //packet.padding(c2scipher.getIVSize());
       packet.padding(c2scipher_size);
       int pad=packet.buffer.buffer[4];
       synchronized(random){
-	random.fill(packet.buffer.buffer, packet.buffer.index-pad, pad);
-      }
+				random.fill(packet.buffer.buffer, packet.buffer.index - pad,
+						pad);
     }
-    else{
+		} else {
       packet.padding(8);
     }
 
@@ -814,6 +813,7 @@
 
   private int s2ccipher_size=8;
   private int c2scipher_size=8;
+
   public Buffer read(Buffer buf) throws Exception{
     int j=0;
     while(true){
@@ -823,10 +823,10 @@
       if(s2ccipher!=null){
         s2ccipher.update(buf.buffer, 0, s2ccipher_size, buf.buffer, 0);
       }
-      j=((buf.buffer[0]<<24)&0xff000000)|
-        ((buf.buffer[1]<<16)&0x00ff0000)|
-        ((buf.buffer[2]<< 8)&0x0000ff00)|
-        ((buf.buffer[3]    )&0x000000ff);
+			j = ((buf.buffer[0] << 24) & 0xff000000)
+					| ((buf.buffer[1] << 16) & 0x00ff0000)
+					| ((buf.buffer[2] << 8) & 0x0000ff00)
+					| ((buf.buffer[3]) & 0x000000ff);
       // RFC 4253 6.1. Maximum Packet Length
       if(j<5 || j>PACKET_MAX_SIZE){
         start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE);
@@ -846,13 +846,16 @@
         if(JSch.getLogger().isEnabled(Logger.FATAL)){
           JSch.getLogger().log(Logger.FATAL, message); 
         }
-        start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE-s2ccipher_size);
+				start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE
+						- s2ccipher_size);
       }
 
       if(need>0){
-	io.getByte(buf.buffer, buf.index, need); buf.index+=(need);
+				io.getByte(buf.buffer, buf.index, need);
+				buf.index += (need);
 	if(s2ccipher!=null){
-	  s2ccipher.update(buf.buffer, s2ccipher_size, need, buf.buffer, s2ccipher_size);
+					s2ccipher.update(buf.buffer, s2ccipher_size, need,
+							buf.buffer, s2ccipher_size);
 	}
       }
 
@@ -866,7 +869,8 @@
           if(need > PACKET_MAX_SIZE){
             throw new IOException("MAC Error");
           }
-          start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE-need);
+					start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE
+							- need);
           continue;
 	}
       }
@@ -881,8 +885,7 @@
 	if(foo!=null){
 	  buf.buffer=foo;
 	  buf.index=5+uncompress_len[0];
-	}
-	else{
+				} else {
 	  System.err.println("fail in inflater");
 	  break;
 	}
@@ -892,50 +895,45 @@
       //System.err.println("read: "+type);
       if(type==SSH_MSG_DISCONNECT){
         buf.rewind();
-        buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 	int reason_code=buf.getInt();
 	byte[] description=buf.getString();
 	byte[] language_tag=buf.getString();
-	throw new JSchException("SSH_MSG_DISCONNECT: "+
-				    reason_code+
-				" "+Util.byte2str(description)+
-				" "+Util.byte2str(language_tag));
+				throw new JSchException("SSH_MSG_DISCONNECT: " + reason_code
+						+ " " + Util.byte2str(description) + " "
+						+ Util.byte2str(language_tag));
 	//break;
-      }
-      else if(type==SSH_MSG_IGNORE){
-      }
-      else if(type==SSH_MSG_UNIMPLEMENTED){
+			} else if (type == SSH_MSG_IGNORE) {
+			} else if (type == SSH_MSG_UNIMPLEMENTED) {
         buf.rewind();
-        buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 	int reason_id=buf.getInt();
         if(JSch.getLogger().isEnabled(Logger.INFO)){
           JSch.getLogger().log(Logger.INFO, 
                                "Received SSH_MSG_UNIMPLEMENTED for "+reason_id);
         }
-      }
-      else if(type==SSH_MSG_DEBUG){
+			} else if (type == SSH_MSG_DEBUG) {
         buf.rewind();
-        buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 /*
-	byte always_display=(byte)buf.getByte();
-	byte[] message=buf.getString();
-	byte[] language_tag=buf.getString();
-	System.err.println("SSH_MSG_DEBUG:"+
-			   " "+Util.byte2str(message)+
-			   " "+Util.byte2str(language_tag));
+				 * byte always_display=(byte)buf.getByte(); byte[]
+				 * message=buf.getString(); byte[] language_tag=buf.getString();
+				 * System.err.println("SSH_MSG_DEBUG:"+
+				 * " "+Util.byte2str(message)+ " "+Util.byte2str(language_tag));
 */
-      }
-      else if(type==SSH_MSG_CHANNEL_WINDOW_ADJUST){
+			} else if (type == SSH_MSG_CHANNEL_WINDOW_ADJUST) {
           buf.rewind();
-          buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 	  Channel c=Channel.getChannel(buf.getInt(), this);
 	  if(c==null){
-	  }
-	  else{
+				} else {
 	    c.addRemoteWindowSize(buf.getInt()); 
 	  }
-      }
-      else if(type==UserAuth.SSH_MSG_USERAUTH_SUCCESS){
+			} else if (type == UserAuth.SSH_MSG_USERAUTH_SUCCESS) {
         isAuthed=true;
         if(inflater==null && deflater==null){
           String method;
@@ -946,8 +944,7 @@
           initInflater(method);
         }
         break;
-      }
-      else{
+			} else {
         break;
       }
     }
@@ -994,6 +991,7 @@
     updateKeys(kex);
     in_kex=false;
   }
+
   private void updateKeys(KeyExchange kex) throws Exception{
     byte[] K=kex.getK();
     byte[] H=kex.getH();
@@ -1007,12 +1005,12 @@
     }
 
     /*
-      Initial IV client to server:     HASH (K || H || "A" || session_id)
-      Initial IV server to client:     HASH (K || H || "B" || session_id)
-      Encryption key client to server: HASH (K || H || "C" || session_id)
-      Encryption key server to client: HASH (K || H || "D" || session_id)
-      Integrity key client to server:  HASH (K || H || "E" || session_id)
-      Integrity key server to client:  HASH (K || H || "F" || session_id)
+		 * Initial IV client to server: HASH (K || H || "A" || session_id)
+		 * Initial IV server to client: HASH (K || H || "B" || session_id)
+		 * Encryption key client to server: HASH (K || H || "C" || session_id)
+		 * Encryption key server to client: HASH (K || H || "D" || session_id)
+		 * Integrity key client to server: HASH (K || H || "E" || session_id)
+		 * Integrity key server to client: HASH (K || H || "F" || session_id)
     */
 
     buf.reset();
@@ -1103,8 +1101,7 @@
 
       method=guess[KeyExchange.PROPOSAL_COMP_ALGS_STOC];
       initInflater(method);
-    }
-    catch(Exception e){ 
+		} catch (Exception e) {
       if(e instanceof JSchException)
         throw e;
       throw new JSchException(e.toString(), e);
@@ -1112,15 +1109,20 @@
     }
   }
 
-  /*public*/ /*synchronized*/ void write(Packet packet, Channel c, int length) throws Exception{
+	/* public *//* synchronized */void write(Packet packet, Channel c,
+			int length) throws Exception {
     long t = getTimeout();
     while(true){
       if(in_kex){
         if(t>0L && (System.currentTimeMillis()-kex_start_time)>t){
-          throw new JSchException("timeout in wating for rekeying process.");
+					throw new JSchException(
+							"timeout in wating for rekeying process.");
+				}
+				try {
+					Thread.sleep(10);
+				} catch (java.lang.InterruptedException e) {
         }
-        try{Thread.sleep(10);}
-        catch(java.lang.InterruptedException e){};
+				;
         continue;
       }
       synchronized(c){
@@ -1144,7 +1146,8 @@
             len=length;
           }
           if(len!=length){
-            s=packet.shift((int)len, (c2smac!=null ? c2smac.getBlockSize() : 0));
+						s = packet.shift((int) len,
+								(c2smac != null ? c2smac.getBlockSize() : 0));
           }
 	  command=packet.buffer.getCommand();
 	  recipient=c.getRecipient();
@@ -1172,10 +1175,8 @@
         try{ 
           c.notifyme++;
           c.wait(100); 
-        }
-        catch(java.lang.InterruptedException e){
-        }
-        finally{
+				} catch (java.lang.InterruptedException e) {
+				} finally {
           c.notifyme--;
         }
       }
@@ -1189,23 +1190,26 @@
     long t = getTimeout();
     while(in_kex){
       if(t>0L && (System.currentTimeMillis()-kex_start_time)>t){
-        throw new JSchException("timeout in wating for rekeying process.");
+				throw new JSchException(
+						"timeout in wating for rekeying process.");
       }
       byte command=packet.buffer.getCommand();
-      //System.err.println("command: "+command);
-      if(command==SSH_MSG_KEXINIT ||
-         command==SSH_MSG_NEWKEYS ||
-         command==SSH_MSG_KEXDH_INIT ||
-         command==SSH_MSG_KEXDH_REPLY ||
-         command==SSH_MSG_KEX_DH_GEX_GROUP ||
-         command==SSH_MSG_KEX_DH_GEX_INIT ||
-         command==SSH_MSG_KEX_DH_GEX_REPLY ||
-         command==SSH_MSG_KEX_DH_GEX_REQUEST ||
-         command==SSH_MSG_DISCONNECT){
+
+			if (command == SSH_MSG_KEXINIT || command == SSH_MSG_NEWKEYS
+					|| command == SSH_MSG_KEXDH_INIT
+					|| command == SSH_MSG_KEXDH_REPLY
+					|| command == SSH_MSG_KEX_DH_GEX_GROUP
+					|| command == SSH_MSG_KEX_DH_GEX_INIT
+					|| command == SSH_MSG_KEX_DH_GEX_REPLY
+					|| command == SSH_MSG_KEX_DH_GEX_REQUEST
+					|| command == SSH_MSG_DISCONNECT) {
         break;
       }
-      try{Thread.sleep(10);}
-      catch(java.lang.InterruptedException e){};
+			try {
+				Thread.sleep(10);
+			} catch (java.lang.InterruptedException e) {
+			}
+			;
     }
     _write(packet);
   }
@@ -1221,7 +1225,9 @@
   }
 
   Runnable thread;
+
   public void run(){
+		System.out.printf("[Session : run] Begin\n");
     thread=this;
 
     byte[] foo;
@@ -1235,19 +1241,16 @@
 
     int stimeout=0;
     try{
-      while(isConnected &&
-	    thread!=null){
+			while (isConnected && thread != null) {
         try{
           buf=read(buf);
           stimeout=0;
-        }
-        catch(InterruptedIOException/*SocketTimeoutException*/ ee){
+				} catch (InterruptedIOException/* SocketTimeoutException */ee) {
           if(!in_kex && stimeout<serverAliveCountMax){
             sendKeepAliveMsg();
             stimeout++;
             continue;
-          }
-          else if(in_kex && stimeout<serverAliveCountMax){
+					} else if (in_kex && stimeout < serverAliveCountMax) {
             stimeout++;
             continue;
           }
@@ -1295,10 +1298,12 @@
 
 try{
 	  channel.write(foo, start[0], length[0]);
-}
-catch(Exception e){
+					} catch (Exception e) {
 //System.err.println(e);
-  try{channel.disconnect();}catch(Exception ee){}
+						try {
+							channel.disconnect();
+						} catch (Exception ee) {
+						}
 break;
 }
 	  int len=length[0];
@@ -1320,7 +1325,8 @@
 	  channel=Channel.getChannel(i, this);
 	  buf.getInt();                   // data_type_code == 1
 	  foo=buf.getString(start, length);
-	  //System.err.println("stderr: "+new String(foo,start[0],length[0]));
+					// System.err.println("stderr: "+new
+					// String(foo,start[0],length[0]));
 	  if(channel==null){
 	    break;
 	  }
@@ -1365,10 +1371,8 @@
 	    channel.eof_remote();
 	  }
 	  /*
-	  packet.reset();
-	  buf.putByte((byte)SSH_MSG_CHANNEL_EOF);
-	  buf.putInt(channel.getRecipient());
-	  write(packet);
+					 * packet.reset(); buf.putByte((byte)SSH_MSG_CHANNEL_EOF);
+					 * buf.putInt(channel.getRecipient()); write(packet);
 	  */
 	  break;
 	case SSH_MSG_CHANNEL_CLOSE:
@@ -1381,12 +1385,11 @@
 	    channel.disconnect();
 	  }
 	  /*
-          if(Channel.pool.size()==0){
-	    thread=null;
-	  }
+					 * if(Channel.pool.size()==0){ thread=null; }
 	  */
 	  break;
 	case SSH_MSG_CHANNEL_OPEN_CONFIRMATION:
+					System.out.printf("[Session : run] SSH_MSG_CHANNEL_OPEN_CONFIRMATION\n");
           buf.getInt(); 
 	  buf.getShort(); 
 	  i=buf.getInt(); 
@@ -1438,8 +1441,7 @@
 	      buf.putInt(channel.getRecipient());
 	      write(packet);
 	    }
-	  }
-	  else{
+					} else {
 	  }
 	  break;
 	case SSH_MSG_CHANNEL_OPEN:
@@ -1447,11 +1449,12 @@
 	  buf.getShort(); 
 	  foo=buf.getString(); 
 	  String ctyp=Util.byte2str(foo);
-          if(!"forwarded-tcpip".equals(ctyp) &&
-	     !("x11".equals(ctyp) && x11_forwarding) &&
-	     !("auth-agent@openssh.com".equals(ctyp) && agent_forwarding)){
+					if (!"forwarded-tcpip".equals(ctyp)
+							&& !("x11".equals(ctyp) && x11_forwarding)
+							&& !("auth-agent@openssh.com".equals(ctyp) && agent_forwarding)) {
             //System.err.println("Session.run: CHANNEL OPEN "+ctyp); 
-	    //throw new IOException("Session.run: CHANNEL OPEN "+ctyp);
+						// throw new
+						// IOException("Session.run: CHANNEL OPEN "+ctyp);
 	    packet.reset();
 	    buf.putByte((byte)SSH_MSG_CHANNEL_OPEN_FAILURE);
 	    buf.putInt(buf.getInt());
@@ -1459,8 +1462,7 @@
 	    buf.putString(Util.empty);
 	    buf.putString(Util.empty);
 	    write(packet);
-	  }
-	  else{
+					} else {
 	    channel=Channel.getChannel(ctyp);
 	    addChannel(channel);
 	    channel.getData(buf);
@@ -1518,24 +1520,23 @@
 	  throw new IOException("Unknown SSH message type "+msgType);
 	}
       }
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       in_kex=false;
       if(JSch.getLogger().isEnabled(Logger.INFO)){
-        JSch.getLogger().log(Logger.INFO,
-                             "Caught an exception, leaving main loop due to " + e.getMessage());
+				JSch.getLogger().log(
+						Logger.INFO,
+						"Caught an exception, leaving main loop due to "
+								+ e.getMessage());
       }
       //System.err.println("# Session.run");
       //e.printStackTrace();
     }
     try{
       disconnect();
-    }
-    catch(NullPointerException e){
+		} catch (NullPointerException e) {
       //System.err.println("@1");
       //e.printStackTrace();
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //System.err.println("@2");
       //e.printStackTrace();
     }
@@ -1543,7 +1544,8 @@
   }
 
   public void disconnect(){
-    if(!isConnected) return;
+		if (!isConnected)
+			return;
     //System.err.println(this+": disconnect");
     //Thread.dumpStack();
     if(JSch.getLogger().isEnabled(Logger.INFO)){
@@ -1551,14 +1553,9 @@
                            "Disconnecting from "+host+" port "+port);
     }
     /*
-    for(int i=0; i<Channel.pool.size(); i++){
-      try{
-        Channel c=((Channel)(Channel.pool.elementAt(i)));
-	if(c.session==this) c.eof();
-      }
-      catch(Exception e){
-      }
-    } 
+		 * for(int i=0; i<Channel.pool.size(); i++){ try{ Channel
+		 * c=((Channel)(Channel.pool.elementAt(i))); if(c.session==this)
+		 * c.eof(); } catch(Exception e){ } }
     */
 
     Channel.disconnect(this);
@@ -1578,22 +1575,23 @@
     thread=null;
     try{
       if(io!=null){
-	if(io.in!=null) io.in.close();
-	if(io.out!=null) io.out.close();
-	if(io.out_ext!=null) io.out_ext.close();
+				if (io.in != null)
+					io.in.close();
+				if (io.out != null)
+					io.out.close();
+				if (io.out_ext != null)
+					io.out_ext.close();
       }
       if(proxy==null){
         if(socket!=null)
 	  socket.close();
-      }
-      else{
+			} else {
 	synchronized(proxy){
 	  proxy.close();	  
 	}
 	proxy=null;
       }
-    }
-    catch(Exception e){
+		} catch (Exception e) {
 //      e.printStackTrace();
     }
     io=null;
@@ -1607,14 +1605,20 @@
     //System.gc();
   }
 
-  public int setPortForwardingL(int lport, String host, int rport) throws JSchException{
+	public int setPortForwardingL(int lport, String host, int rport)
+			throws JSchException {
     return setPortForwardingL("127.0.0.1", lport, host, rport);
   }
-  public int setPortForwardingL(String boundaddress, int lport, String host, int rport) throws JSchException{
+
+	public int setPortForwardingL(String boundaddress, int lport, String host,
+			int rport) throws JSchException {
     return setPortForwardingL(boundaddress, lport, host, rport, null);
   }
-  public int setPortForwardingL(String boundaddress, int lport, String host, int rport, ServerSocketFactory ssf) throws JSchException{
-    PortWatcher pw=PortWatcher.addPort(this, boundaddress, lport, host, rport, ssf);
+
+	public int setPortForwardingL(String boundaddress, int lport, String host,
+			int rport, ServerSocketFactory ssf) throws JSchException {
+		PortWatcher pw = PortWatcher.addPort(this, boundaddress, lport, host,
+				rport, ssf);
     Thread tmp=new Thread(pw);
     tmp.setName("PortWatcher Thread for "+host);
     if(daemon_thread){
@@ -1623,37 +1627,55 @@
     tmp.start();
     return pw.lport;
   }
+
   public void delPortForwardingL(int lport) throws JSchException{
     delPortForwardingL("127.0.0.1", lport);
   }
-  public void delPortForwardingL(String boundaddress, int lport) throws JSchException{
+
+	public void delPortForwardingL(String boundaddress, int lport)
+			throws JSchException {
     PortWatcher.delPort(this, boundaddress, lport);
   }
+
   public String[] getPortForwardingL() throws JSchException{
     return PortWatcher.getPortForwarding(this);
   }
 
-  public void setPortForwardingR(int rport, String host, int lport) throws JSchException{
+	public void setPortForwardingR(int rport, String host, int lport)
+			throws JSchException {
     setPortForwardingR(null, rport, host, lport, (SocketFactory)null);
   }
-  public void setPortForwardingR(String bind_address, int rport, String host, int lport) throws JSchException{
-    setPortForwardingR(bind_address, rport, host, lport, (SocketFactory)null);
+
+	public void setPortForwardingR(String bind_address, int rport, String host,
+			int lport) throws JSchException {
+		setPortForwardingR(bind_address, rport, host, lport,
+				(SocketFactory) null);
   }
-  public void setPortForwardingR(int rport, String host, int lport, SocketFactory sf) throws JSchException{
+
+	public void setPortForwardingR(int rport, String host, int lport,
+			SocketFactory sf) throws JSchException {
     setPortForwardingR(null, rport, host, lport, sf);
   }
-  public void setPortForwardingR(String bind_address, int rport, String host, int lport, SocketFactory sf) throws JSchException{
-    ChannelForwardedTCPIP.addPort(this, bind_address, rport, host, lport, sf);
+
+	public void setPortForwardingR(String bind_address, int rport, String host,
+			int lport, SocketFactory sf) throws JSchException {
+		ChannelForwardedTCPIP.addPort(this, bind_address, rport, host, lport,
+				sf);
     setPortForwarding(bind_address, rport);
   }
 
-  public void setPortForwardingR(int rport, String daemon) throws JSchException{
+	public void setPortForwardingR(int rport, String daemon)
+			throws JSchException {
     setPortForwardingR(null, rport, daemon, null);
   }
-  public void setPortForwardingR(int rport, String daemon, Object[] arg) throws JSchException{
+
+	public void setPortForwardingR(int rport, String daemon, Object[] arg)
+			throws JSchException {
     setPortForwardingR(null, rport, daemon, arg);
   }
-  public void setPortForwardingR(String bind_address, int rport, String daemon, Object[] arg) throws JSchException{
+
+	public void setPortForwardingR(String bind_address, int rport,
+			String daemon, Object[] arg) throws JSchException {
     ChannelForwardedTCPIP.addPort(this, bind_address, rport, daemon, arg);
     setPortForwarding(bind_address, rport);
   }
@@ -1661,21 +1683,35 @@
   private class GlobalRequestReply{
     private Thread thread=null;
     private int reply=-1;
+
     void setThread(Thread thread){
       this.thread=thread;
       this.reply=-1;
     }
-    Thread getThread(){ return thread; }
-    void setReply(int reply){ this.reply=reply; }
-    int getReply(){ return this.reply; }
+
+		Thread getThread() {
+			return thread;
+		}
+
+		void setReply(int reply) {
+			this.reply = reply;
+		}
+
+		int getReply() {
+			return this.reply;
   }
+	}
+
   private GlobalRequestReply grr=new GlobalRequestReply();
-  private void setPortForwarding(String bind_address, int rport) throws JSchException{
+
+	private void setPortForwarding(String bind_address, int rport)
+			throws JSchException {
     synchronized(grr){
     Buffer buf=new Buffer(100); // ??
     Packet packet=new Packet(buf);
 
-    String address_to_bind=ChannelForwardedTCPIP.normalize(bind_address);
+			String address_to_bind = ChannelForwardedTCPIP
+					.normalize(bind_address);
 
     grr.setThread(Thread.currentThread());
 
@@ -1692,8 +1728,7 @@
       buf.putString(Util.str2byte(address_to_bind));
       buf.putInt(rport);
       write(packet);
-    }
-    catch(Exception e){
+			} catch (Exception e) {
       grr.setThread(null);
       if(e instanceof Throwable)
         throw new JSchException(e.toString(), (Throwable)e);
@@ -1703,18 +1738,22 @@
     int count = 0;
     int reply = grr.getReply();
     while(count < 10 && reply == -1){
-      try{ Thread.sleep(1000); }
-      catch(Exception e){
+				try {
+					Thread.sleep(1000);
+				} catch (Exception e) {
       }
       count++; 
       reply = grr.getReply();
     }
     grr.setThread(null);
     if(reply != 1){
-      throw new JSchException("remote port forwarding failed for listen port "+rport);
+				throw new JSchException(
+						"remote port forwarding failed for listen port "
+								+ rport);
     }
     }
   }
+
   public void delPortForwardingR(int rport) throws JSchException{
     ChannelForwardedTCPIP.delPort(this, rport);
   }
@@ -1726,23 +1765,26 @@
     }
     String foo=getConfig(method);
     if(foo!=null){
-      if(method.equals("zlib") ||
-         (isAuthed && method.equals("zlib@openssh.com"))){
+			if (method.equals("zlib")
+					|| (isAuthed && method.equals("zlib@openssh.com"))) {
         try{
           Class c=Class.forName(foo);
           deflater=(Compression)(c.newInstance());
           int level=6;
-          try{ level=Integer.parseInt(getConfig("compression_level"));}
-          catch(Exception ee){ }
-          deflater.init(Compression.DEFLATER, level);
+					try {
+						level = Integer
+								.parseInt(getConfig("compression_level"));
+					} catch (Exception ee) {
         }
-        catch(Exception ee){
+					deflater.init(Compression.DEFLATER, level);
+				} catch (Exception ee) {
           throw new JSchException(ee.toString(), ee);
           //System.err.println(foo+" isn't accessible.");
         }
       }
     }
   }
+
   private void initInflater(String method) throws JSchException{
     if(method.equals("none")){
       inflater=null;
@@ -1750,14 +1792,13 @@
     }
     String foo=getConfig(method);
     if(foo!=null){
-      if(method.equals("zlib") ||
-         (isAuthed && method.equals("zlib@openssh.com"))){
+			if (method.equals("zlib")
+					|| (isAuthed && method.equals("zlib@openssh.com"))) {
         try{
           Class c=Class.forName(foo);
           inflater=(Compression)(c.newInstance());
           inflater.init(Compression.INFLATER, 0);
-        }
-        catch(Exception ee){
+				} catch (Exception ee) {
           throw new JSchException(ee.toString(), ee);
 	    //System.err.println(foo+" isn't accessible.");
         }
@@ -1769,21 +1810,55 @@
     channel.setSession(this);
   }
 
-  public void setProxy(Proxy proxy){ this.proxy=proxy; }
-  public void setHost(String host){ this.host=host; }
-  public void setPort(int port){ this.port=port; }
-  void setUserName(String username){ this.username=username; }
-  public void setUserInfo(UserInfo userinfo){ this.userinfo=userinfo; }
-  public UserInfo getUserInfo(){ return userinfo; }
-  public void setInputStream(InputStream in){ this.in=in; }
-  public void setOutputStream(OutputStream out){ this.out=out; }
-  public void setX11Host(String host){ ChannelX11.setHost(host); }
-  public void setX11Port(int port){ ChannelX11.setPort(port); }
-  public void setX11Cookie(String cookie){ ChannelX11.setCookie(cookie); }
+	public void setProxy(Proxy proxy) {
+		this.proxy = proxy;
+	}
+
+	public void setHost(String host) {
+		this.host = host;
+	}
+
+	public void setPort(int port) {
+		this.port = port;
+	}
+
+	void setUserName(String username) {
+		this.username = username;
+	}
+
+	public void setUserInfo(UserInfo userinfo) {
+		this.userinfo = userinfo;
+	}
+
+	public UserInfo getUserInfo() {
+		return userinfo;
+	}
+
+	public void setInputStream(InputStream in) {
+		this.in = in;
+	}
+
+	public void setOutputStream(OutputStream out) {
+		this.out = out;
+	}
+
+	public void setX11Host(String host) {
+		ChannelX11.setHost(host);
+	}
+
+	public void setX11Port(int port) {
+		ChannelX11.setPort(port);
+	}
+
+	public void setX11Cookie(String cookie) {
+		ChannelX11.setCookie(cookie);
+	}
+
   public void setPassword(String password){
     if(password!=null)
       this.password=Util.str2byte(password);
   }
+
   public void setPassword(byte[] password){ 
     if(password!=null){
       this.password=new byte[password.length];
@@ -1819,18 +1894,27 @@
     Object foo=null;
     if(config!=null){
       foo=config.get(key);
-      if(foo instanceof String) return (String)foo;
+			if (foo instanceof String)
+				return (String) foo;
     }
     foo=jsch.getConfig(key);
-    if(foo instanceof String) return (String)foo;
+		if (foo instanceof String)
+			return (String) foo;
     return null;
   }
 
   public void setSocketFactory(SocketFactory sfactory){ 
     socket_factory=sfactory;
   }
-  public boolean isConnected(){ return isConnected; }
-  public int getTimeout(){ return timeout; }
+
+	public boolean isConnected() {
+		return isConnected;
+	}
+
+	public int getTimeout() {
+		return timeout;
+	}
+
   public void setTimeout(int timeout) throws JSchException {
     if(socket==null){
       if(timeout<0){
@@ -1842,19 +1926,21 @@
     try{
       socket.setSoTimeout(timeout);
       this.timeout=timeout;
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       if(e instanceof Throwable)
         throw new JSchException(e.toString(), (Throwable)e);
       throw new JSchException(e.toString());
     }
   }
+
   public String getServerVersion(){
     return Util.byte2str(V_S);
   }
+
   public String getClientVersion(){
     return Util.byte2str(V_C);
   }
+
   public void setClientVersion(String cv){
     V_C=Util.str2byte(cv);
   }
@@ -1867,7 +1953,9 @@
     write(packet);
   }
 
-  private static final byte[] keepalivemsg=Util.str2byte("keepalive@jcraft.com");
+	private static final byte[] keepalivemsg = Util
+			.str2byte("keepalive@jcraft.com");
+
   public void sendKeepAliveMsg() throws Exception{
     Buffer buf=new Buffer();
     Packet packet=new Packet(buf);
@@ -1879,13 +1967,27 @@
   }
   
   private HostKey hostkey=null;
-  public HostKey getHostKey(){ return hostkey; }
-  public String getHost(){return host;}
-  public String getUserName(){return username;}
-  public int getPort(){return port;}
+
+	public HostKey getHostKey() {
+		return hostkey;
+	}
+
+	public String getHost() {
+		return host;
+	}
+
+	public String getUserName() {
+		return username;
+	}
+
+	public int getPort() {
+		return port;
+	}
+
   public void setHostKeyAlias(String hostKeyAlias){
     this.hostKeyAlias=hostKeyAlias;
   }
+
   public String getHostKeyAlias(){
     return hostKeyAlias;
   }
@@ -1894,6 +1996,7 @@
     setTimeout(interval);
     this.serverAliveInterval=interval;
   }
+
   public void setServerAliveCountMax(int count){
     this.serverAliveCountMax=count;
   }
@@ -1901,6 +2004,7 @@
   public int getServerAliveInterval(){
     return this.serverAliveInterval;
   }
+
   public int getServerAliveCountMax(){
     return this.serverAliveCountMax;
   }
@@ -1914,8 +2018,7 @@
       return null;
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "CheckCiphers: "+ciphers);
+			JSch.getLogger().log(Logger.INFO, "CheckCiphers: " + ciphers);
     }
 
     java.util.Vector result=new java.util.Vector();
@@ -1932,8 +2035,8 @@
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
       for(int i=0; i<foo.length; i++){
-        JSch.getLogger().log(Logger.INFO, 
-                             foo[i]+" is not available.");
+				JSch.getLogger()
+						.log(Logger.INFO, foo[i] + " is not available.");
       }
     }
 
@@ -1944,12 +2047,10 @@
     try{
       Class c=Class.forName(cipher);
       Cipher _c=(Cipher)(c.newInstance());
-      _c.init(Cipher.ENCRYPT_MODE,
-              new byte[_c.getBlockSize()],
+			_c.init(Cipher.ENCRYPT_MODE, new byte[_c.getBlockSize()],
               new byte[_c.getIVSize()]);
       return true;
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       return false;
     }
   }
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/Util.java jsch-0.1.44/src/com/jcraft/jsch/Util.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/Util.java	2010-10-19 17:25:56.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/Util.java	2011-03-02 15:42:18.127336001 +0900
@@ -29,6 +29,7 @@
 
 package com.jcraft.jsch;
 import java.net.Socket;
+import java.util.StringTokenizer;
 
 class Util{
 
@@ -101,20 +102,28 @@
   static String[] split(String foo, String split){
     if(foo==null)
       return null;
-    byte[] buf=Util.str2byte(foo);
+
+//    byte[] buf=Util.str2byte(foo);
     java.util.Vector bar=new java.util.Vector();
-    int start=0;
-    int index;
-    while(true){
-      index=foo.indexOf(split, start);
-      if(index>=0){
-	bar.addElement(Util.byte2str(buf, start, index-start));
-	start=index+1;
-	continue;
-      }
-      bar.addElement(Util.byte2str(buf, start, buf.length-start));
-      break;
+//    int start=0;
+//    int index;
+//    while(true){
+//			index = foo.indexOf(split, start);
+//			if (index >= 0) {
+//				bar.addElement(Util.byte2str(buf, start, index - start));
+//				start = index + 1;
+//				continue;
+//			}
+//      bar.addElement(Util.byte2str(buf, start, buf.length-start));
+//      break;
+//    }
+    
+    StringTokenizer tokenizer = new StringTokenizer(foo, split);
+    while (tokenizer.hasMoreTokens()) {
+    	String s = tokenizer.nextToken();
+    	bar.addElement(s);
     }
+    
     String[] result=new String[bar.size()];
     for(int i=0; i<result.length; i++){
       result[i]=(String)(bar.elementAt(i));
@@ -391,10 +400,10 @@
   static byte[] str2byte(String str, String encoding){
     if(str==null) 
       return null;
-    try{ return str.getBytes(encoding); }
-    catch(java.io.UnsupportedEncodingException e){
+//    try{ return str.getBytes(encoding); }
+//    catch(java.io.UnsupportedEncodingException e){
       return str.getBytes();
-    }
+//    }
   }
 
   static byte[] str2byte(String str){
@@ -406,10 +415,10 @@
   }
 
   static String byte2str(byte[] str, int s, int l, String encoding){
-    try{ return new String(str, s, l, encoding); }
-    catch(java.io.UnsupportedEncodingException e){
+//    try{ return new String(str, s, l, encoding); }
+//    catch(java.io.UnsupportedEncodingException e){
       return new String(str, s, l);
-    }
+//    }
   }
 
   static String byte2str(byte[] str){
Only in jsch-0.1.44: tmp
